#include "ModuleSwitch.h"
#include <iostream>

namespace mdd{
    ModuleSwitch::ModuleSwitch(){
        json default_val;
        default_val["value"] = 42;
        auto veri = [](const json& val){
            if(val.find("value")==val.end())
                return false;
            return true;
        };
        addInput("Switch",0, default_val, veri);
        addInput("Value0",0, default_val, veri);
        addInput("Default",0, default_val, veri);
        addOutput("Value",0, default_val);
        setType("Switch");
    }
    bool ModuleSwitch::update(){
        int index = getInputValue(0)["value"].get<int>();
        if(index == 0){
            index = 1;
        }
        if(index > getInputs().size() - 1){
            index = getInputs().size() - 1;
        }
        json ret = getInputValue(index)["value"];
        if (ret.dump() != getOutput(0)->getValue()["value"].dump()) {
            setOutputValue(0)["value"] = ret ;
            return true;
        }
        else{
            return false;
        }
    }
}