#include "ProcessorManual.h"
#include <iostream>

namespace mdd {
    ProcessorManual::ProcessorManual()
    {
        _iteration = std::make_shared<Output>("Value", "{ \"value\": 0 }"_json);
    }

    bool ProcessorManual::update() {
        bool ret = false;
        bool group_state = true;
        while(group_state){
            _iteration->getValueInternal()["value"]= _iteration->getValue()["value"].get<int>()+1;
            std::cout << _iteration->getValue().dump()<<"\n";
            group_state = false;
            for (int i = 0; i < getModules().size(); ++i) {
                bool module_state = getModule(i)->update();
                if(module_state){
                    group_state=true;
                    ret = true;
                }
            }
        }
        return ret;
    }

    std::shared_ptr<IOutput> ProcessorManual::getIteration(){
        return _iteration;
    }
}